
/*  functions used by lm_auto and lm_lods    */

void alloc_y (int **** pyy, int nl, int pdsz)
{
    int j;

    *pyy = calloc (2, sizeof (int **));
    alloc_chk (WHERE, *pyy);
    (*pyy)[0] = calloc (nl + 1, sizeof (int *));
    alloc_chk (WHERE, (*pyy)[0]);
    (*pyy)[1] = calloc (nl + 1, sizeof (int *));
    alloc_chk (WHERE, (*pyy)[1]);
    for (j = 0; j <= nl; ++j)
    {
	(*pyy)[0][j] = calloc (pdsz + 1, sizeof (int));
	alloc_chk (WHERE, (*pyy)[0][j]);
	(*pyy)[1][j] = calloc (pdsz + 1, sizeof (int));
	alloc_chk (WHERE, (*pyy)[1][j]);
    }
    return;
}

void set_markdat(int *** yy, int nl, int nc)
{
    int i, j, c, posp, cfound;

    for (i = 1; i <= NObs; ++i)
    {
        if (!(posp = get_posit(IObs[i])))
            give_warn (ERA_mdp, IObs[i]);

        else for (j = 1; j <= nl; ++j)
	{
	    yy[0][j][posp] = Dat1[j][i];
	    yy[1][j][posp] = Dat2[j][i];
	}
    }
    for (c = 0; c < nc; ++c)
    {
        cfound = 0;
        for (i = 1; i <= NObs; ++i)
            if (posp = get_posit(IObs[i]))
	        if ((nghd[posp].component) == (c + 1))
                    cfound = 1;
        if (!cfound)
            give_warn(ERA_nmd, c+1);
    }
    return;
}

void set_traitdat(int *** yy, int *qdex, int *trtphen, int pdsz, int nc) 
{
    int c, k, i, np, kfound, ifound;

    char *k_txt[5] = {
         "",
         "(homozygous normal) ",
         "(phenotypic normal for recessive trait, not implemented)",
         "(recessive carrier) ",
         "(recessive affected)"
                     };

    for (c = 0; c < nc; ++c)
    {
        kfound = 0;
        printf ("\n Component %d:", c + 1);
        for (k = 4; k > 0; --k)                 /* k=0 unknown        */
        {
            ifound = 0; np=0;
            for (i = 0; i < pdsz; ++i)
            {
                if (nghd[i].component == c + 1  &&  data[i][5] == k)	 
                                                /* k=0 unknown        */
                {
                    if (TraitPheno)        /* ADDED CODE, EAT, 9/00 and 10/00 */
                      {  ++np; qdex[i] = np;
                         trtphen[i]=data[i][5]; 
                         if (!kfound)
                           { printf("\n"); kfound = 1; }
                         if (!ifound)
                            printf("\n    trait phenotype %d %s:",
                              trtphen[i], k_txt[k]);
                        if (ifound && !(ifound % 8 ))
                            printf("\n                            "
                                                "                ");
                        ++ifound;
                        printf (" %d", nghd[i].self);
                       }
                    else
                      {
                    if (k == 2)                 /* phenotypic normal  */
                            ;                   /* for recessive trait*/
                                                /* not implemented    */
  	            if (k == 4)
  	            {
  	                yy[0][0][i] = 2;
  	                yy[1][0][i] = 2;
  	            }				/* recessive affected */
  	            if (k == 3)
  	            {
  	                yy[0][0][i] = 1;
  	                yy[1][0][i] = 2;
  	            }				/* recessive carrier  */
  	            if (k == 1)
  	            {
  	                yy[0][0][i] = 1;
  	                yy[1][0][i] = 1;
  	            }				/*  homozyyg normal    */

                    if (k != 2)
                    {
                        if (!kfound)
                        {
                            printf("\n");
                            kfound = 1;
                        }
                        if (!ifound)
                            printf("\n    trait genotype %d %d %s:",
                              yy[0][0][i], yy[1][0][i], k_txt[k]);
                        if (ifound && !(ifound % 8 ))
                            printf("\n                            "
                                                "                ");
                        ++ifound;
	                printf (" %d", nghd[i].self);
                    } }
                }
            }
            if (ifound)
                printf ("\n");
        }
        if (!kfound)
            printf ("  no trait data\n");
    }
    printf ("\n\n");
    fflush(stdout);

    return;
}

void set_probgam (int nc) 
{
    int c, i, posp;

    for (c = 0; c < nc; ++c)
        if (!NPr[c])
        {
            give_err (ERA_ncd, c + 1);
        }
	else for (i = 0; i < NPr[c]; ++i)
	{
            if (!(posp = get_posit(Probands[c][i])))
                give_up (ERA_inp, Probands[c][i]);
	    else if ((nghd[posp].component) != (c + 1))
                give_up (ERA_pnc, Probands[c][i], c + 1);

	    Probands[c][i] = posp;
	}
    return;
}

