                                
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*      errsprogs.h:  error messages produced by MORGAN               */
/*                    main programs and subroutine libraries          */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
    
#ifndef ERRSPROGS_H
#define ERRSPROGS_H
   
/* error codes which result in the error messages defined in           */
/* defined in Errrs[][] below		                               */
               
enum prEnums 
    { ERR_nul,
      ERR_siz,
      ERR_nex,
      ERR_urd,
      ERC_dp1,
      ERC_dup,
      ERC_1p1,
      ERC_1pr,
      ERC_0p1,
      ERC_0pr,
      ERC_uas,
      ERC_1bp,
      ERC_bpr,
      ERC_ch1,
      ERC_chr,
      ERR_inh,
      ERR_mtx,
      ERR_mxg,
      ERR_mxe,
      ERR_noo,
      ERC_frm,
      ERC_fbi,
      ERC_fbr,
      ERC_fri,
      ERC_frr,
      ERC_nof,
      ERC_fin,
      ERC_fsx,
      ERC_wpf,
      ERC_cco,
      ERC_csa,
      ERC_coi,
      ERA_mdp,
      ERA_nmd,
      ERA_ncd,
      ERA_pnc,
      ERA_nap,
      ERA_inp,
      ERN_cmp,
      ERN_mxn,
      ERN_sx1,
      ERN_sex,
      ERN_1pt,
      ERN_ngh,
      ERN_xpa,
      ERN_xma,
      ERN_nop,
      ERN_nam,
      ERN_mng,
      ERN_sxm,
      ERN_sxf,
      ERQ_hff,
      ERP_con,
      ERP_nzd,
      ERP_swc,
      ERP_npv,
      ERP_nnp,
      ERP_nav,
      ERP_ueo,
      ERS_fex,
      ERS_fof,
      ERS_pfe,
      ERS_mal,
      ERS_mxw,
      ERR_qit } ;
    
#ifdef DEFINE_DATA
char *Errrs[] = {
 "***" ,                                                         /*ERR_nul*/
 " %s():  Pedigree size must be greater than 2" ,                /*ERR_siz*/
 " %d individuals expected" ,                                    /*ERR_nex*/
 " %s():  Unread record(s) remain in pedigree file" ,            /*ERR_urd*/
 " %s():  1 duplicate name, %d, was found" ,                     /*ERC_dp1*/
 " %s():  %d duplicate names were found\n"                
 "              %d was the first duplicate name found",          /*ERC_dup*/ 
 " %s():  Individual %d has only one parent named" ,             /*ERC_1p1*/
 " %s():  %d individuals have only one parent named\n"        
 "                  %d was the first such individual" ,          /*ERC_1pr*/
 " %s():  Named parent(s) of individual %d are not in pedigree" ,/*ERC_0p1*/
 " %s():  Named parent(s) of %d individuals are not in pedigree\n" 
 "                %d was the first such individual found" ,      /*ERC_0pr*/
 " Unsuccessful assignment of gender:" ,                         /*ERC_uas*/
 " %s():  %d individual, %d, has parent(s) of wrong sex" ,       /*ERC_1bp*/
 " %s():  %d individuals have parent(s) of wrong sex\n"   
 "                 %d was the first such individual" ,           /*ERC_bpr*/
 " %s():  Unable to assign chronological order to individual %d",/*ERC_ch1*/ 
 " %s():  Unable to assign chronological order to %d individuals\n"
 "                %d was the first unassigned name" ,            /*ERC_chr*/
 " %s():  Failed for individual %d" ,                            /*ERR_inh*/
 " %s():  Matrix not positive definite" ,                        /*ERR_mtx*/
 " %s():  Genetic covariance matrix not positive definite" ,     /*ERR_mxg*/
 " %s():  Environmental covariance matrix not positive definite",/*ERR_mxe*/
 " A pedigree component with %d member(s) has no observed individuals\n" 
 " %d is the first member of this component",                    /*ERR_noo*/
 " Not enough data in pedigree record #%d" ,                     /*ERC_frm*/
 " \"%s\" is not valid integer in pedigree record #%d" ,         /*ERC_fbi*/
 " \"%s\" is not valid real number in pedigree record #%d" ,     /*ERC_fbr*/
 " Range error for integer \"%s\" in pedigree record #%d" ,      /*ERC_fri*/
 " Range error for real number \"%s\" in pedigree record #%d" ,  /*ERC_frr*/
 " Unable to assign output pedigree file\n"
 " Please provide output file name in parameter statement or "
                                                 "command line", /*ERC_nof*/ 
 " Bad name \"%s\" in pedigree record #%d" ,                     /*ERC_fin*/
 " Bad gender \"%s\" in pedigree record #%d" ,                   /*ERC_fsx*/
 " A new pedigree file will be written:",                        /*ERC_wpf*/
 "    the input pedigree was not in chronological order",        /*ERC_cco*/
 "    there are changes to the pedigree in assignment of gender",/*ERC_csa*/
 "    there are changes to the pedigree in the observed indicator",
                                                                 /*ERC_coi*/
 " Marker data given for individual %d, who is not in the pedigree",  
                                                                 /*ERA_mdp*/ 
 " No marker data given for component %d" ,                      /*ERA_nmd*/
 " No proband gametes specified for component %d" ,              /*ERA_ncd*/
 " Proband %d not member of component %d" ,                      /*ERA_pnc*/
 " No proband gametes" ,                                         /*ERA_nap*/
 " Proband %d is not a member of the pedigree" ,                 /*ERA_inp*/
 " Problem:  %s() called even though all individuals are already "
                  "in components" ,                              /*ERN_cmp*/
 " Largest name in pedigree file is %d; the maximum name allowed is %d\n" 
 " Use \"allow maximum names\" statement to permit larger names",/*ERN_mxn*/
 " %d incorrectly sexed parent" ,                                /*ERN_sx1*/
 " %d incorrectly sexed parents" ,                               /*ERN_sex*/
 " Individual %d has only one parent" ,                          /*ERN_1pt*/
 " No neighborhood for individual %d.  Oops!" ,                  /*ERN_ngh*/
 " %s():  Impossible father for %d" ,                            /*ERN_xpa*/
 " %s():  Impossible mother for %d" ,                            /*ERN_xma*/
 " %s():  Warning! Have no individual in the pedigree"
                     " corresponding to row_index %d" ,          /*ERN_nop*/
 " Name %d out of range " ,                                      /*ERN_nam*/
 " %s():  Tried to make nghd twice for %d" ,                     /*ERN_mng*/
 " %s():  Sex change operation for mother %d" ,                  /*ERN_sxm*/
 " %s():  Sex change operation for father %d" ,                  /*ERN_sxf*/
 " %s():  CAUTION;  program not guaranteed for half-founder %d" ,/*ERQ_hff*/
 " DATA ERROR:  non simply connected pedigree" ,                 /*ERP_con*/
 " ERROR:  %d individuals have non-zero degree" ,                /*ERP_nzd*/
 " Cannnot switch dominance models" ,                            /*ERP_swc*/
 " %s():  Warning;  negative pivot found at %d" ,                /*ERP_npv*/
 " %s():  # negative pivots = %d" ,                              /*ERP_nnp*/
 " %s():  WARNING: why polygenic peel with no additive variance ??\n"
 "            use mjrpeel to peel major gene models\n"
 "            use envonly to compute likelihoods for non-genetic model" ,
                                                                 /*ERP_nav*/
 " Using envonly as you maybe meant to gives %f" ,               /*ERP_ueo*/
 " %c%s \"%s\" already exists\n"
 " Writing to it would destroy its contents" ,                   /*ERS_fex*/
 " Can't open %s \"%s\"  %s" ,                                   /*ERS_fof*/
 " Expected pedigree file to contain 0, 1 or more parameter statements,\n"
 "     terminated by a line starting with \"%s\",\n"
 "     followed by pedigree data" ,                              /*ERS_pfe*/
 " Malloc failed:  %s" ,                                         /*ERS_mal*/
 " Maximum number of warning messages permitted has been exceeded" ,
                                                                 /*ERS_mxw*/
 " Program quitting\n\n" } ;                                     /*ERR_qit*/
#else
  extern char *Errrs[];

#endif  /*DEFINE_DATA*/
 
#endif  /*ERRSPROGS_H*/
     
