
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       stuff.h:  header file for Stuff/                              */
/*                 this header file includes:                          */
/*                    the current MORGAN version no.                   */
/*                    function prototyes for Stuff/ functions          */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef STUFF_H
#define STUFF_H 

#include "incs.h"

                                      /*** MORGAN version no. is here ***/
#define MORGVERS "MORGAN Version 2.3"

#define DATASINK "/dev/null"

#define WHERE    __FILE__, __LINE__

GLOBAL int nWarns;                      /*total no. of warnings issued  */


                                        /*function prototypes for       */
                                        /*Stuff/ library:               */
void alloc_chk       (char *, int, void *);
void give_warn       (int, ...);
void give_warn_where (char *, int, int, ...);
void give_err        (int, ...);
void give_err_where  (char *, int, int, ...);
void give_up         (int, ...);
void give_up_where   (char *, int, int, ...);

void print_head (char *),            print_tail (void);
void printhost  (void); 
void print_val  (double),            print_val5 (double);
int  intWid     (int, int),          decWid     (double, double, int); 
int  fldWid     (double, double, int);
int max         (int, int),          min        (int, int);
double dist2rf  (double),            rf2dist    (double);
double gendist  (double),            recomb     (double);

FILE * open_fil (char *);
FILE * open_ped (void);
void   copy_fnam(char *, char *);
FILTAB_PTR get_filent(char *);
FILTAB_PTR get_filtyp(char);

#endif  /*STUFF_H*/

