/*************************************************************************
  Routine to realise switches from the prior.
  There can be cases where this might not be compatible with data.
  April 1994, EAT.

  Added, January 1999; 
     routine to set segs for trait locus using a partial specification
  and
    routine to set marker segs and data conditional on those,
  and
    routine to set genotypes of observed individuals
  (EAT)

  Updated to use the linked list of switches; EAT Jan 2001.

***************************************************************************/

#include "msample.h"

void realise(int nl, double *rec, int ns)

 { int i,j, ii, ss, **xx;
      for (i=0; i<pedsize; ++i)  
           for (j=0; j<=nl; ++j) { xx0[j][i] = -1; xx1[j][i]= -1; }

      for (i=1; i<= ns; ++i)
	   {  ii = (meiosis[i].ind).index; ss = meiosis[i].sex;
              if (ss==0) xx=xx0; else xx=xx1;
              
              if (rans() <0.5) xx[0][ii]=0; else  xx[0][ii]=1; 
                   for (j=1; j<=nl; ++j)
                      { if (rans() > rec[j-1]) xx[j][ii]=xx[j-1][ii];
                        else             xx[j][ii] = 1 - xx[j-1][ii]; } }             
 }

void trait_segs(int ns, int *ind, int *sx)
  { int i, ii, ss, **xx, k;
      for (i=0; i<pedsize; ++i)  { xx0[0][i] = -1; xx1[0][i]= -1; }
      
       for (i=1; i<= ns; ++i)
	   {  ii = ind[i]; ss = sx[i];
              if (ss==0)  { xx=xx0; k=7; }
                     else { xx=xx1; k=6; }

               xx[0][ii] = data[ii][k];
               if (xx[0][ii] == -1)
                     { if (rans() <0.5) xx[0][ii]=0; 
                          else  xx[0][ii]=1; } }

  printf("\n list of init segs");
    for (i=0; i< pedsize; ++i)
         { printf ("\n %d %d;", nghd[i].index, nghd[i].self);
            printf ("  %2d %2d", xx1[0][i], xx0[0][i]); }
    fflush(stdout);
 
 }

void next_marker_segs(int ns, int *ind, int *sx, int mf,int mt,double rec)
/* from marker mf, at recombination rec, set marker mt    */
   { int i, ii, ss, **xx;
      for (i=0; i<pedsize; ++i)  
           { xx0[mt][i] = -1; xx1[mt][i]= -1; }

    printf ("\n chk, simulating from locus %d to %d at rec %f",
                      mf, mt, rec);
      for (i=1; i<= ns; ++i)
	   {  ii = ind[i]; ss = sx[i];
              if (ss==0)  xx=xx0; else xx=xx1;

              if (xx[mf][ii] != -1) 
               { if (rans() > rec) xx[mt][ii]=xx[mf][ii];
                     else       xx[mt][ii] = 1 - xx[mf][ii]; } } 
   }


void set_genotypes (int nfou, int loc, double *freq, int *gd1, int *gd2)
 {  int *allotype, k,kk, a1;      /* indexing of types of observed genes */
    double qf, ff;

    allotype = (int *)calloc((size_t)(2*nfou +1),sizeof(int));
    for (k=1; k<= 2*nfou; ++k) allotype[k]=0;

                                     /* trait locus, special case */
    if (loc==0) { for (k=1; k<= 2*nfou; ++k) allotype[k]=1;
                  allotype[2]=2;
                  for (kk =1; kk <= NObs; ++kk) 
                    { k=posit[IObs[kk]][0];
                      gg0[loc][k] = allotype[gg0[loc][k]]*gd2[kk];
                      gg1[loc][k] = allotype[gg1[loc][k]]*gd1[kk]; }
                 }
                                    /*  marker locus  */
    else { for (kk =1; kk <= NObs; ++kk) 
            { k=posit[IObs[kk]][0];
             if (allotype[gg0[loc][k]] ==0) 
                 { qf= rans(); a1=0; ff=0.0;
                   while (qf > ff) { ++a1; ff+= freq[a1]; }
                   allotype[gg0[loc][k]]=a1; }
             if (allotype[gg1[loc][k]] ==0) 
                 { qf= rans(); a1=0; ff=0.0;
                   while (qf > ff) { ++a1; ff+= freq[a1]; }
                   allotype[gg1[loc][k]]=a1; }
            }
           for (kk =1; kk <= NObs; ++kk) 
            { k=posit[IObs[kk]][0];
              gg0[loc][k] = allotype[gg0[loc][k]]*gd2[kk];
              gg1[loc][k] = allotype[gg1[loc][k]]*gd1[kk]; }
            }

    free(allotype); return;

  }
