/* -------------check_pars:  called by PolyEM programs --------------
 *
 * check_pars compares the number of starting values for fixed effect 
 * levels against the number of levels found by sortdat after the 
 * pedigree file is read						
 *							  MAJ Jun 1997 
 */

int check_pars(int np, int max_cpsiz)
{
    int i, j, n;

    for (j = 1; j <= NFix; ++j)  	/* compares # of levels of fixed */
	if (IFix[j] > LEVELS)		/* effects to # allowed		 */
	    err_typ = ERR_FFL;

    if (!err_typ)			/* compares # starting values to */
	for (i = 0; i < FMAX_REAL; ++i)	/* # levels found		 */
	    for (j = 1, n = 0; j < FMAX_FEF; ++j)
	    {
		if (selff[j])
		    ++n;
		if (nstartff[i][j])
		{
		    if (seltrff[i][j])
			if (nstartff[i][j] != IFix[n])
			    err_typ = ERR_FFN;
		}
	    }
    if (ICh == 1)			/* if eigenvalues are to be 	 */
        if (!pmx->pcod == 'u')		/* computed, test component size */
	    if (max_cpsiz > allw_cmpsiz)  /* against limit		 */
            {		
	        err_typ = ERR_CHG;
                err_txt = pmx->pnam;
            }
    if (ICh == 0)			/* if eigenvalues were input,	 */
	if (n_eigen != np)		/* tests against # observed indvd*/
	    err_typ = ERR_EIP;

    if (np > allw_obsiz)		/* tests # observed individuals  */
	err_typ = ERR_OBS;		/* against limit		 */

					/* need a test on component size here!*/
    if (err_typ)
	if (proc_err())
	    return FALSE;

    return TRUE;
}

