
/* ------------input_eigen.c:  called by PolyEM programs --------------	*/
/*			       reads the eigenvalues file		*/

int input_eigen(int np)
{
    int k, r;
    char *eignam;
    FILE *pf;

    eignam = get_filent(IGEN)->fname;
    if (!(pf = fopen(eignam, "r")))
    {
        err_typ = ERR_OEF;
        err_txt = eignam;
        if (proc_err())
            return FALSE;
    }
    peigen = malloc((np + 1) * sizeof(double));
    alloc_chk(WHERE, peigen);

    k = 0;
    while (k < np) 
    {
        r = fscanf(pf, "%lf", peigen + k + 1);
        if (r != EOF)
            ++k;
        else
            break;
    }
    if (r != EOF)
        r = fscanf(pf,"%*s");

    fclose(pf);

    if (k != np || r != EOF)
    {
        err_typ = ERR_EIE;
        if (proc_err())
            return FALSE;
    }
    return TRUE;
}
