/*************************************************************************
  
  program name: peelseq_set.c
  
  program to preprocess and set peeling sequence, so it is now read in
    once only, and is used by index, not by name.
  
  also modify peeling sequence notation, so that (in data file)
    pivots at end of pedigree are zero, but final pivots are -1, 
    so can accumulate probabilities over several pedigrees.
  
  EAT March 1997.
  
  The final 0/-1 pivots, are now processed to -1, -2 by this program, to
  avoid confusion with individuals of index 0   (EAT, May 1997)
  
**************************************************************************/

#include "nghds.h"
#include "peelie.h"

/**************************************************************************/


void peelseq_set(char *peel_file)
{
    int nch, ipivot, ma, pa, child;
    int j, k;
    FILE *peel_seq;

    if (!(peel_seq = open_fil(PEEL)))
        give_up(ERR_qit);

    ipivot = 0;
    k = 0;

    while (ipivot > -1)
    {
	fscanf(peel_seq, "%d %d %d %d", &pa, &ma, &ipivot, &nch);
	k = k + 4;
	for (j = 1; j <= nch; ++j)
	{
	    fscanf(peel_seq, "%d", &child);
	    ++k;
	}
    }
    fclose(peel_seq);

    peelseq = (int *) malloc((k + 1) * sizeof(int));
    printf(" The peeling sequence file has been read:  %d entries\n\n", k);

    if (!(peel_seq = open_fil(PEEL)))
        give_up(ERR_qit);

    ipivot = 0;
    k = 0;
    while (ipivot > -1)
    {
	fscanf(peel_seq, "%d %d %d %d", &pa, &ma, &ipivot, &nch);
	peelseq[k] = posit[pa][0];
	peelseq[k + 1] = posit[ma][0];
	if (ipivot > 0)
	    peelseq[k + 2] = posit[ipivot][0];
	else
	    peelseq[k + 2] = ipivot - 1;
	peelseq[k + 3] = nch;
	k = k + 4;
	for (j = 1; j <= nch; ++j)
	{
	    fscanf(peel_seq, "%d", &child);
	    peelseq[k] = posit[child][0];
	    ++k;
	}
    }
    fclose(peel_seq);
}
